#include <iostream.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

enum tag {Single, Pair};

char Res[50]; // 

struct LispEl
{
  tag Tag;
  union
  {
   char Leaf; //.
   struct     // .
   {
     LispEl* Left;
     LispEl* Right;
    } Pr;
  };
};

class Tree
{
  private:
    LispEl* Root; //   .
  public:
    void PrintTree (LispEl*, int);
    void Enter (LispEl**, int&, char *);
    LispEl** GetTree() { return &Root; };
    LispEl* GetTree1() { return Root; };
    Tree () { Root = NULL; };
};

// ------------    ----------
void Tree::PrintTree (LispEl* W, int l)
// p p,   p W.
{
  int i;

  if  (W->Tag!=Single)
  {
     PrintTree (W->Pr.Right,l+1);
     for (i=1;i<=l;i++) cout << "   "; 
	  cout << "#\n";
     PrintTree (W->Pr.Left,l+1);
  }
  else
  {
    for (i=1;i<=l;i++) cout << "   "; 
    cout << W->Leaf << endl;
  }
}

void Tree::Enter (LispEl** T, int& i, char *Str)
//p p p,
// S-p  LISP.
{
  char X;

  cout << " "; X = Str[i]; i++;
  //   p X  p p.
  if (X=='#')
  {
   (*T) = new (LispEl);
   (**T).Tag = Pair;
   Enter (&((*T)->Pr.Left),i,Str);
   Enter (&((*T)->Pr.Right),i,Str);
  }
  else
  {
   (*T) = new (LispEl);
   (**T).Tag = Single; (*T)->Leaf = X;
  }
}

// ---------------  LISP --------------
LispEl* MAKEATOM (char C)
{

  LispEl* h = new (LispEl);
  h->Tag = Single; 
  h->Leaf = C;
  return h;
}

LispEl* CONS (LispEl* X,LispEl* Y)
//p S-p   S-p X  Y.
{
  LispEl* p = new (LispEl);

  p->Tag = Pair; p->Pr.Left = X; p->Pr.Right = Y;
  return p;
}

int ATOM (LispEl* X)
//pp  p.
{
  return (X->Tag == Single);
}

LispEl* CAR (LispEl* X)
// p  S-p.
{
  return X->Pr.Left;
}

LispEl* CDR (LispEl* X)
// p  S-p.
{
  return X->Pr.Right;
}

int EQ (LispEl* X, LispEl* Y)
//pp p  p S-p.
{
  return (X->Leaf == Y->Leaf);
}

char VAL (LispEl* A)
{
  return A->Leaf;
}

char FIRSTATOM (LispEl* X)
//p p  S-p.
{
  if (ATOM (X)) return X->Leaf;
  else  FIRSTATOM (CAR (X));
}

int EQUAL (LispEl* X, LispEl* Y)
//pp  p S-p X  Y.
{
  if  (ATOM (X) || ATOM (Y))
  {
    if  (ATOM (X) && ATOM (Y)) return EQ (X,Y);
    else  return 0;
  }
  else
  {
    if  (EQUAL (CAR (X),CAR (Y))) return EQUAL (CDR (X),CDR (Y));
    else  return 0;
  }
}

// ------------   -------------
void Convert (char *Str, char (*Result)[])
{
  char Ch[2]; // .

  Ch[1]='\0'; strcpy(*Result,"");
  for (int k=0;k<strlen(Str);k++)
  {
    Ch[0] = Str[k];
    if  (Ch[0]=='(') strcat((*Result),"#");
    else
     if  (Ch[0]!=')' && Ch[0]!='.' && Ch[0]!=' ')
             strcat ((*Result),Ch);
  }
}

int Contains (LispEl* S, char X)
{
  if (ATOM (S)) return (X==VAL(S));
  else  return (Contains(CAR(S),X) || Contains(CDR(S),X));
}

// ------  - -------------
char*  Cod (LispEl* S, char X)
//p .
//S - p p  p ,
//X - "p"  p S,
//Res -    .
{
  if (ATOM (S))  return strcpy((Res),"");
  else
    if  (Contains (CAR(S),X))
    {
      char temp[50]; temp[0]='O'; temp[1]='\0';
      strcat(temp, Cod(CAR(S),X));
      strcpy (Res,temp);
    }
    else
     if  (Contains(CDR(S),X))
     {
       char temp[50]; temp[0]='L'; temp[1]='\0';
       strcat(temp, Cod(CDR(S),X));
       strcpy (Res,temp);
     }
  return Res;
}

char Decod  (LispEl* S, char (*A)[])
//p .
//A -  ,
//S - p p  p .
{
  if  (strlen(*A)==0 || ATOM (S)) return VAL(S);
  else
  {
    if  ((*A)[0] == 'O')
    {
      int j=strlen(*A);
      for(int i=1;i<j;i++) (*A)[i-1]=(*A)[i];
      (*A)[j-1]='\0';
      return Decod (CAR(S),&(*A));
    }
    else
     if  ((*A)[0] == 'L')
     {
       int j=strlen(*A);
       for(int i=1;i<j;i++) (*A)[i-1]=(*A)[i];
       (*A)[j-1]='\0';
       return  Decod (CDR(S),&(*A));
     }
  }
}

void main()
{
  char Str[23];    //p  p p.
  char Result[23]; //p   p.
  int i=0;         // p.
  char Symbol;
  char Code[50],Cd[50];
  Tree C;

  cout << "p p p  p \n";
  cout << "    p...\n";
  cout << "  p... \n";
  gets (Str);
  Convert(Str,&Result);
  strcpy(Str,Result);
  C.Enter (C.GetTree(),i,Str);
  cout << endl;
  C.PrintTree (C.GetTree1(),0);
  cout << " ---------------------------------------- \n";
  getch();
  for(i=1;i<=3;i++)
  {
    cout << "p   ";
    cin >> Symbol;
    if  (Contains (C.GetTree1(),Symbol))
    {
      Cod (C.GetTree1(),Symbol);
      cout << " ... " << Res << endl;
     }
    else  cout << " -   p !\n";
  }
  cout << " ---------------------------------------- \n";
  getch();
  cout << "p  p...\n";
  for(i=1;i<=3;i++)
  {
    cout << " ... ";
    cin >> Code;
    strcpy(Cd,Code);
    cout << " - ";
    Cod (C.GetTree1(), Decod(C.GetTree1(),&Code));
    if  (!strcmp (Res,Cd))
       cout << (Decod (C.GetTree1(),&Cd)) << endl;
    else  cout << " p!\n";
  }
}